﻿Imports System.Net
Imports System.IO
Imports System.Text
Imports System.Text.RegularExpressions

Namespace Ollama

    Module Module_Ollama

        Friend Running As Boolean = False

        Private Request As WebRequest
        Private Response As WebResponse
        Private ResponseStream As Stream
        Private Reader As StreamReader

        Private URL As String = "http://localhost:11434/api/generate"
        'Private URL As String = "http://192.168.0.147:11434/api/generate"

        Friend Sub SendPrompt(ByVal model As String, ByVal prompt As String)
            ' -------------------------------------------------------------------
            prompt = NetToJava(prompt)
            ' -------------------------------------------------------------------
            Request = HttpWebRequest.Create(URL)
            request.Method = "POST"
            'request.ContentType = "application/json"
            ' -------------------------------------------------------------------
            Dim body As String
            body = "{""model"":""" + model + """,""prompt"":""" + prompt + """}"

            Dim byteArray As Byte() = Encoding.UTF8.GetBytes(body)
            request.ContentLength = byteArray.Length

            Using dataStream As Stream = request.GetRequestStream()
                dataStream.Write(byteArray, 0, byteArray.Length)
            End Using
            ' -------------------------------------------------------------------- Execute and get response
            Try
                response = request.GetResponse()
                responseStream = response.GetResponseStream()
                reader = New StreamReader(responseStream, Encoding.UTF8)
            Catch e As Exception
                ReceivedNewText(vbCrLf + vbCrLf + "Model not found, please download it and retry." + vbCrLf)
                StopAndCloseAll()
            End Try
        End Sub

        Friend Sub StopAndCloseAll()
            If Request IsNot Nothing Then
                Request.Abort()
                Request = Nothing
                'response.Close()
                'responseStream.Close()
                'reader = Nothing

                Running = False
                Form1.UpdateRunButton()
            End If
        End Sub

        Friend Sub ReadResponse()
            If Request Is Nothing Then Return
            If Reader Is Nothing Then Return
            If Not Reader.EndOfStream() Then
                Dim s As String = Reader.ReadLine()
                s = ExtractTranslatedText(s)
                s = JavaToNet(s)
                ReceivedNewText(s)
            End If
        End Sub

        Private Sub ReceivedNewText(ByVal txt As String)
            txt = txt.Replace(vbCrLf, vbLf)
            txt = txt.Replace(vbLf, vbCrLf)
            Form1.TextBox1.Text += txt
            Form1.TextBox1.SelectionStart = 99999
            Form1.TextBox1.ScrollToCaret()
        End Sub

        Private Function ExtractTranslatedText(ByVal txt As String) As String
            Dim n As Int32 = txt.IndexOf("response")
            txt = txt.Substring(n + 11)
            n = txt.IndexOf(""",""done"":")
            If n < 0 Then Return ""
            Dim s1 As String = txt.Substring(0, n)
            Dim s2 As String = txt.Substring(n + 9).Replace("}", "")
            If s2.StartsWith("true") Then ResponseDone()
            Debug.Print(s2)
            Return s1
        End Function

        Private Sub ResponseDone()
            Running = False
            Form1.UpdateRunButton()
        End Sub

        Private Function NetToJava(ByVal s As String) As String
            If s = "" Then Return ""
            '
            s = Replace(s, "\", "\\")
            s = Replace(s, """", "\""")
            s = Replace(s, vbTab, "\t")
            '
            s = Replace(s, vbCrLf, "\n")
            s = Replace(s, vbCr, "\r")
            s = Replace(s, vbLf, "\f")
            '
            s = ReplaceChars_LessThan32(s)
            '
            Return s
        End Function

        Private Function ReplaceChars_LessThan32(ByVal s As String) As String
            Dim c() As Char = s.ToCharArray
            For i As Int32 = 0 To c.Length - 1
                'When using CHINESE then:
                'System.ArgumentException: 
                'The output byte buffer is too small to contain the encoded data,
                'encoding 'Unicode (UTF-8)' fallback 'System.Text.EncoderReplacementFallback'.
                'Parameter name : bytes'
                Try
                    If Asc(c(i)) < 32 Then
                        c(i) = " "c
                    End If
                Catch
                End Try
            Next
            Return New String(c)
        End Function

        Private Function JavaToNet(ByVal s As String) As String
            Try
                If s Is Nothing Then Return ""
                ' ------------------------------------------ convert  "},  to  \    
                s = s.Replace("""},", "\\")
                ' ------------------------------------------ convert, for example: "\u00e9" to "é"
                s = Regex.Unescape(s)
                ' ------------------------------------------
                s = s.Replace("https://", " https://")
            Catch
                ' ------------------------------------------ Some escape sequence produces errors 
                ' ------------------------------------------ Example: "C:"},Path"},To"},Your"},Audio\File.wav"
                'Beep()
            End Try
            Return s
        End Function


 
        ' -------------------------------------------------------------------------------------------| chr 0
        '"{"model":"phi3","created_at":"2024-08-19T09:09:56.5388894Z","response":" reg","done":false} se} e}

        '    '{"model":"phi3","created_at":"2024-08-18T18:38:39.9129183Z","response":"The","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:40.1401406Z","response":" color","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:40.2941338Z","response":" of","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:40.4410527Z","response":" the","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:40.9251127Z","response":" sky","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:41.1278102Z","response":" appears","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:41.2869638Z","response":" as","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:41.4458161Z","response":" it","done":false}
        '    '{"model":"phi3","created_at":"2024-08-18T18:38:41.8239399Z","response":" does","done":false}

        ' true,"done_reason":"stop","context":[106,1645,108,69551,2063,5227,1654,107,108,106,2516,108,28543,235341,4407,13533,235269,53656,235265,637,2575,2063,158124,235336,44416,235248,108],"total_duration":2022088300,"load_duration":71781200,"prompt_eval_count":13,"prompt_eval_duration":114265000,"eval_count":16,"eval_duration":1835190000



    End Module

End Namespace